#include "numbered.h"

bool Numbered::trimmed_sequence() {
    char *q;
    int size, u;
/*
a: -i1-37
first part of a: -i1-
second part of a: 37
trimmed sequence: -i1
first part of trimmed sequence: -i
second part of trimmed sequence: 1
*/

// Trimming the first part of a
    trimmed_sequence_length = strlen(f) - TRIMMING;
    pt = new char[ trimmed_sequence_length + 1 ];
    trimmed = true;

    memcpy(pt, f, trimmed_sequence_length);
    pt[trimmed_sequence_length] = '\0';
    u = strspn( strrev(pt), "0123456789");
    if(u == 0) {
        delete pt;
        delete ft;
        delete st;
        pt = NULL;
        ft = NULL;
        st = NULL;
        trimmed = false;
        return trimmed;
    }

    span = u;
    non_number_length = trimmed_sequence_length - span;

// Copying the second part of trimmed sequence
    size = span + 1;
    st = new char[size];

    q = & f[non_number_length];
    memcpy(st, q, span);
    st[span] = '\0';

// Copying the first part of trimmed sequence
    size = non_number_length + 1;
    ft = new char[size];

    q = & f[0];
    memcpy(ft, q, non_number_length);
    ft[non_number_length] = '\0';
    return true;
}

Numbered::~Numbered() {
    delete f;
    delete ft;
    delete p;
    delete pt;
    delete s;
    delete st;
}

std::string Numbered::parameter() {
    if(trimmed) {
        std::string first_trimmed(ft);
        return first_trimmed;
    } else {
        std::string first(f);
        return first;
    }

}

Numbered::Numbered(char *a) {
    char *q;
    int size;

    pt = NULL;
    ft = NULL;
    st = NULL;
    trimmed = false;

    length = strlen(a);
    p = new char[ length + 1 ];

// Copying all
    strcpy(p, a);
    span = strspn( strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    size = span + 1;
    s = new char[size];

    q = & a[non_number_length];
    memcpy(s, q, span);
    s[span] = '\0';

// Copying the first part of a
    size = non_number_length + 1;
    f = new char[size];

    memcpy(f, a, non_number_length);
    f[non_number_length] = '\0';
}

int Numbered::number() {
    using namespace std;

    string sequence(s);
    stringstream ss(sequence);
    int n;
    ss >> n;
    return n;
}

int Numbered::subnumber() {
    using namespace std;

    int k = -1; // error

    if(trimmed) {
        string sequence(st);
        stringstream ss(sequence);
        ss >> k;
    }

    return k;
}
