#ifndef TIME_NAME_H
#define TIME_NAME_H

#define BINARY_FILE ".bin"
#define BUFFER_SIZE 384
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 256
#define FROM_LOG_REPEAT_SETTING 4
#define GROUPING_INDICATOR "-g"
#define LABEL_HEIGHT 20
#define MAIN_HEIGHT 438
#define MAIN_WIDTH 380
#define MAPPING_INDICATOR "-m"
#define MIDDLE_HEIGHT 478
#define MIDDLE_WIDTH 420
#define NONSAMPLING_PERIOD 1000 // milliseconds
#define REMOVE_ERROR_TEXT "remove_e.txt"
#define SERIAL_TEXT "serial.txt"
#define TEXT_FILE ".txt"
#define TRANSPARENT_INDICATOR "-w-"
#define TRUE_TEXT "true.txt"
#define UND "und"
#define VERY_SMALL_BUFFER_SIZE 16
#include <fstream>
#include <iostream>
#include <math.h>
#include <sstream>
#include <stdio.h>
#include <string>
#include <sys\stat.h>
#include <time.h>

class TimeName {
    const std::string HYPHEN;
    std::string base, name, extension, timeName;

public:
    TimeName(std::string & b, std::string & e): HYPHEN("-") {
        base = b;
        extension = e;
        name = base;
        readSerialNumber();
    }

    TimeName(std::string & b, const char *e): HYPHEN("-") {
        base = b;
        const std::string ex(e);
        extension = ex;
        name = base;
        readSerialNumber();
    }

    TimeName(const char *b, const char *e): HYPHEN("-") {
        const std::string ba(b);
        base = ba;
        const std::string ex(e);
        extension = ex;
        name = base;
        readSerialNumber();
    }

    ~TimeName(){}

    std::string getTimeName() const {
        return timeName;
    }

    std::string temporaryName(bool);
    void readSerialNumber();
    void setSerialNumber();
    void zeroSerialNumber();
};

bool removeTemporaryFiles();

#endif // TIME_NAME_H
