/*
Kopic VCL Version 1.12
Producing Loto-7 combinations
Copyright 2017 Sogaya

C++Builder 5

*/

#include <vcl.h>
#include "kopicDLL.h"
#include "kopicLog.h"
#include "kun.h"
#include "numbered.h"
#pragma hdrstop
USERES("kopic.res");
USEFORM("kopicMain.cpp", Form1);
USEFORM("Focus.cpp", OKRightDlg);
USEFORM("C:\BORLAND\CBUILDER5\OBJREPOS\OKCANCL1.cpp", OKBottomDlg);
USEFORM("Version.cpp", OKHelpBottomDlg);
USEFORM("Weight.cpp", OKRightDlg1);
USEUNIT("kun.cpp");
USEUNIT("OS-specific.cpp");
USEUNIT("TimeName.cpp");
USEUNIT("kopicLog.cpp");
USEUNIT("mt19937ar.cpp");
USEUNIT("Numbered.cpp");
USEUNIT("OutputNewLine.cpp");
USEUNIT("rannuText.cpp");
USEUNIT("Split.cpp");
USEUNIT("Xorshift.cpp");
USEUNIT("MT.cpp");

extern char *random_number;
extern MANAGE_MEMO *mm;
KUN_CODE *kunCode;

int messagePane(char *p) {
    HMODULE dll = LoadLibrary("Message.dll");
    if (dll == NULL) {
        return 0;
    }

    SHOW_FORM showForm = (SHOW_FORM)GetProcAddress(dll, "showForm");
    if (showForm == NULL) {
        return 0;
    }

    showForm(p);

    FreeLibrary(dll);
    return 0;
}

KUN_CODE readFilesBeforeCreatingWindows(Split & a) {
    using namespace std;

    bool remove_first = true;
    char *b;
    char *stop;
    char buffer[LARGE_BUFFER_SIZE];
    const bool COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;
    const string CSV_DECREMENT("-cd");
    const string CSV_FILE("-c");
    const string EASY_TO_SEE("-t");
    const string FROM_NOT_38("-38-");
    const string FULL_SWING("-f");
    const string GROUPING("-g");
    const string KUN_FILE("-k");
    const string MAPPING("-m");
    const string NEW_XBM("-n");
    const string NO_EDITING("-e-");
    const string NO_REMOVING("-r-");
    const string NO_WEIGHTING("-w-");
    const string OUTPUT("-o");
    const string PRNG_MT = "-pm";
    const string PRNG_XORSHIFT = "-px";
    const string SIZE("-s");
    const string USE_SQUARE_NOT_DIAMOND("-d-");
    const string version_comments("-VC");
    const string version_guide("-V");
    const string XBM_RECOVERY("-y");
    int decrement_according_to_file = 1;
    int cell_height = CELL_HEIGHT;
    int cell_width = CELL_WIDTH;
    int diamond = DIAMOND;
    int k, u;
    int argc = a.count();
    KUN_CODE kc;
    Numbered *n = new Numbered("-s4-4");
    string *fileName = new string(KOPIC_XBM);
    string argument, non_number, s;
    unsigned int d;

    ifstream manage(MANAGE_TEXT);
    if( manage.fail() ) {
        ofstream file(MANAGE_TEXT);
        file << "1" << endl; // decrement_according_to_file 
        file << CELL_WIDTH << endl;
        file << CELL_HEIGHT << endl;
        file << "0" << endl; // kc.diamond
    } else {
        if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
            string b(buffer);
            stringstream sb(b);
            sb >> decrement_according_to_file;
            if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                string w(buffer);
                stringstream sw(w);
                sw >> cell_width;
                if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                    string h(buffer);
                    stringstream sh(h);
                    sh >> cell_height;
                    if( manage.getline(buffer, LARGE_BUFFER_SIZE) ) {
                        string d(buffer);
                        stringstream sd(d);
                        sd >> diamond;
                    }
    
                }

            }

        }

    }

    kc.cell_height = CELL_HEIGHT;
    kc.cell_width = CELL_WIDTH;
    kc.decrement_by_n = decrement_according_to_file;
    kc.defectiveCsv = true;
    kc.diamond = diamond;
    kc.from_not_38 = false;
    kc.full_swing = false;
    kc.grouping = false;
    kc.kun_shrink = false;
    kc.mapping = false;
    kc.newXbm = false;
    kc.outputLines = KOPIC_REPEAT - KOPIC_FROM;
    kc.prng = MERSENNE_TWISTER;
    kc.sharp_symbols = false;
    kc.weight = true;

    checkWidth(&kc);

    for(int i = 1; i < argc; ++i) {
        if( CSV_FILE == a.argument(i) ) {
            kc.csv = true;
        } else if( EASY_TO_SEE == a.argument(i) ) {
            kc.sharp_symbols = true;
        } else if( FROM_NOT_38 == a.argument(i) ) {
            kc.from_not_38 = true; // Use From, not 38.
        } else if( FULL_SWING == a.argument(i) ) {
            kc.full_swing = true;
        } else if( GROUPING == a.argument(i) ) {
            kc.grouping = true;
        } else if( KUN_FILE == a.argument(i) ) {
            kc.kun_shrink = true;
        } else if( MAPPING == a.argument(i) ) {
            kc.mapping = true;
        } else if( NEW_XBM == a.argument(i) ) {
            kc.newXbm = true;
        } else if( NO_EDITING == a.argument(i) ) {
            kc.defectiveCsv = false;
        } else if( NO_REMOVING == a.argument(i) ) {
            remove_first = false;
        } else if( NO_WEIGHTING == a.argument(i) ) {
            kc.weight = false;
        } else if( PRNG_MT == a.argument(i) ) {
            kc.prng = MERSENNE_TWISTER;
        } else if( PRNG_XORSHIFT == a.argument(i) ) {
            kc.prng = XORSHIFT;
        } else if( USE_SQUARE_NOT_DIAMOND == a.argument(i) ) {
            kc.diamond = SHOEBOX;
        } else if( version_guide == a.argument(i) ) {
            guide(WITHOUT_COMMENTS);
            delete fileName; delete n;
            kc.code = VERSION_GUIDE;
            return kc;
        } else if( version_comments == a.argument(i) ) {
            guide(COMMENTS);
            delete fileName; delete n;
            kc.code = VERSION_COMMENTS;
            return kc;
        } else if( XBM_RECOVERY == a.argument(i) ) {
            createKopicXbm();
            delete fileName; delete n;
            kc.code = RECOVERY;
            return kc;
        } else {
            d = argument.find(CSV_DECREMENT);
            if(d != string::npos) {
                delete n;
                s = a.argument(i);
                strcpy(buffer, s.c_str() );
                n = new Numbered(buffer);
                kc.decrement_by_n = n->number();
                if( n->parameter() == CSV_DECREMENT ) {
                    kc.csv = true;
                    continue;
                }

                kc.decrement_by_n = 0;
            }

            d = argument.find(OUTPUT);
            if(d != string::npos) {
                delete n;
                s = a.argument(i);
                strcpy(buffer, s.c_str() );
                n = new Numbered(buffer);
                kc.outputLines = n->number();
                if( n->parameter() == OUTPUT ) {
                    continue;
                }

                kc.outputLines = KOPIC_REPEAT - KOPIC_FROM;
            }

            d = argument.find(SIZE);
            if(d != string::npos) {
                delete n;
                s = a.argument(i);
                strcpy(buffer, s.c_str() );
                n = new Numbered(buffer);
                kc.cell_height = n->number();
                if( n->trimmed_sequence() ) {
                    kc.cell_width = n->subnumber();
                    if( n->parameter() == SIZE ) {
                        continue;
                    }

                }

                kc.cell_height = CELL_HEIGHT;
                kc.cell_width = CELL_WIDTH;
            }

            delete fileName;
            fileName = new string( a.argument(i) );
        }

    }

    delete n;
    if(remove_first) {
        createRemoveErrorText();
        removeTemporaryFiles();
    }

    strcpy(kc.file_name, fileName->c_str() );
    delete fileName;
    return kc;
}

PICK_CODE read_rewrite_if_necessary(const char *file_name, KUN_CODE *p) {
    PICK_CODE pc;

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    pc.code = UNPICKED;
    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
        pc.code = FULL_SWING_TEXT;
    }

    return pc;
}

PICK_CODE settingBeforehand(const char *f, KUN_CODE *p) {
    using namespace std;

    const string RANNU_TXT(RANDOM_NUMBER_TEXT);
    const string YEN = "\\";
    string pathName = currentDirectory();
    pathName += YEN;
    pathName += RANNU_TXT;

    mm->csv = false;
    mm->grouping = p->grouping;
    mm->interval_0 = 1;
    mm->interval_1 = 37;
    mm->kilo = KILOBYTES;
    mm->lineCount = LARGE_NUMBER;
    mm->pathName = pathName;
    mm->prng = p->prng;
    mm->produce_rannu_text = true;

    bool check[100]; // 0 to 99
    bool csv = mm->csv;
    bool grouping = mm->grouping;
    bool produce_rannu_text = mm->produce_rannu_text;
    bool rannu_text_required, wide_range;
    int b;
    int interval_0 = mm->interval_0;
    int interval_1 = mm->interval_1;
    int lineCount = mm->lineCount;
    int prng = mm->prng;
    long kilo = mm->kilo;
    long table_size = 1L;
    PICK_CODE pc;
    RandomNumber *rn;

    strcpy(pc.file_name, f);

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(pc.file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
    }

// Reading KOPIC_CSV
    Pickable *k;
    if(p->weight) {
        if(p->mapping) {
            k = new Mapping();
            rannu_text_required = true;
            wide_range = false;
        } else {
            if(p->grouping) {
                k = new Tint();
                rannu_text_required = true;
                wide_range = true;
            } else {
                k = new Weight();
                rannu_text_required = false;
                wide_range = false;
            }

        }

    } else {
        k = new Transparent();
        rannu_text_required = true;
        wide_range = false;
    }

    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int count = k->comboCount();
    int from = k->idling();
    long seed = (long)k->seedData();
    if(seed == 0L) {
        long e = (long)time(NULL);
        seed = e & SEED_MASK;
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();

        int q = (int) rn->random_integer();
        int repeat = k->repetition();
        from += q%repeat;
    } else {
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();
    }

    mm->seed = seed;
    if(rannu_text_required) {
        ifstream test(RANDOM_NUMBER_TEXT);
        if( test.fail() ) {
            rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, p->grouping, produce_rannu_text);
            rn->createRannuText(mm->pathName);
        } else {
            test.close();
        }

// Reading RANDOM_NUMBER_TEXT to produce a random-number array
        setTwoDigitNumbers(); // two_digit_number[][]
        readRannuText(&table_size); // random_number[u]
        k->randomNumberArray(table_size, from);
        if(wide_range) {
            k->wideRange();
        }

    } else {
// Because the function internally produces random numbers, an external random-number table is unnecessary.
        k->internallyProduce(rn); // Weight::function( )

        random_number = new char[MAIN_BUFFER_SIZE];
        memset(random_number, 0, MAIN_BUFFER_SIZE);
        table_size = (long)MAIN_BUFFER_SIZE;
    }

    delete k;
    delete rn;
    pc.code = UNPICKED;
    return pc;
}

void checkWidth(KUN_CODE *p) {
    switch(p->cell_width) {
    case 9:
        p->cell_height = 9;
        p->diamond = 0;
        break;
    case 10:
        p->cell_height = 10;
        p->diamond = 2;
        break;
    default:
        if(p->cell_width > 10) {
            p->diamond = 1;
        } else {
            p->diamond = 3;
        }

        break;
    }

}

void guide(bool comments) {
    using namespace std;

    ofstream file(VERSION_TEXT);
    if(comments) {
        file << "kopic VCL Version " << VERSION << "\n" << endl 
            << "kopic         # Read kopic.xbm " << endl 
            << "kopic -c      # Produce kopic.csv from kopic.xbm " << endl 
            << "kopic -c -38- # Use From, not 38. " << endl 
            << "kopic -cd2    # Produce kopic.csv from kopic.xbm and decrement by 2. " << endl 
            << "kopic -e-     # Do not edit kopic.csv " << endl 
            << "kopic -f      # Produce full-swing kopic.txt from kopic.csv " << endl 
            << "kopic -g      # Use rannu.txt to weight balls. " << endl 
            << "kopic -k      # Produce kopic.kun from kopic.xbm " << endl 
            << "kopic -m      # Read many_one.txt " << endl 
            << "kopic -o30    # Output 30 lines. " << endl 
            << "kopic -pm     # MT " << endl 
            << "kopic -px     # xorshift " << endl 
            << "kopic -r-     # Do not remove temporary files. " << endl 
            << "kopic -s9-9   # Every cell is 9 pixels wide and 9 pixels high. " << endl 
            << "kopic -t      # Produce kopic.txt from kopic.xbm " << endl 
            << "kopic -y      # recovery " << endl 
            << "kopic -V      # version " << endl 
            << "kopic -VC     # version with comments " << endl 
            << "kopic -w-     # Do not weight balls. " << endl 
            << "kopic file_name.csv    # Read file_name.csv regardless of kopic.xbm " << endl 
            << "kopic file_name.kun    # Produce kopic.txt from file_name.kun " << endl 
            << "kopic file_name.txt    # Produce kopic.xbm from file_name.txt " << endl 
            << "kopic file_name.xbm    # Read file_name.xbm " << endl 
            << "kopic file_name.txt -n # Produce and read new kopic.xbm " << endl;
    } else {
        file << "kopic VCL Version " << VERSION << "\n" << endl 
            << "kopic         " << endl 
            << "kopic -c      " << endl 
            << "kopic -c -38- " << endl 
            << "kopic -cd2    " << endl 
            << "kopic -e-     " << endl 
            << "kopic -f      " << endl 
            << "kopic -g      " << endl 
            << "kopic -k      " << endl 
            << "kopic -m      " << endl 
            << "kopic -o30    " << endl 
            << "kopic -pm     " << endl 
            << "kopic -px     " << endl 
            << "kopic -r-     " << endl 
            << "kopic -s9-9   " << endl 
            << "kopic -t      " << endl 
            << "kopic -y      " << endl 
            << "kopic -V      " << endl 
            << "kopic -VC     " << endl 
            << "kopic -w-     " << endl 
            << "kopic file_name.csv    " << endl 
            << "kopic file_name.kun    " << endl 
            << "kopic file_name.txt    " << endl 
            << "kopic file_name.xbm    " << endl 
            << "kopic file_name.txt -n " << endl;
    }

}

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int) {
    bool drawXbm = false;
    char GAP[] = " ";
    const bool EXECUTABLE = true;
    PICK_CODE pc;
    Split a( ::GetCommandLine(), GAP, EXECUTABLE);
    KUN_CODE kc = readFilesBeforeCreatingWindows(a);
    kc = readXbm(kc);
    if(kc.cell_height < 2) {
        kc.cell_height = 2;
    }

    if(kc.cell_width < 2) {
        kc.cell_width = 2;
    }

    switch(kc.code) {
    case CSV_SPECIFIED:
        pc = kopicLog(kc.file_name, &kc);
        return messagePane(pc.temporary_file_name);
    case XBM_READ:
        if(kc.full_swing) {
            read_rewrite_if_necessary(KOPIC_CSV, &kc);
            drawXbm = false;
        } else {
            drawXbm = true;
        }

        break;
    default:
        break;
    }

    if(kc.newXbm) {
        kc = readXbm(kc);
        if(kc.cell_height < 2) {
            kc.cell_height = 2;
        }

        if(kc.cell_width < 2) {
            kc.cell_width = 2;
        }

        switch(kc.code) {
        case XBM_READ:
            kopicLog(KOPIC_CSV, &kc);
            break;
        }

    } else {
        if(! drawXbm) {
            return 0;
        }

    }

    kunCode = &kc;
    pc = settingBeforehand(KOPIC_CSV, &kc);
    if(pc.code != UNPICKED) {
        return 0;
    }

    try {
         Application->Initialize();
         Application->Title = "Kopic";
         Application->HelpFile = "C:\\kopicVCL\\KOPIC.HLP";
         Application->CreateForm(__classid(TForm1), &Form1);
         Application->CreateForm(__classid(TOKRightDlg), &OKRightDlg);
         Application->CreateForm(__classid(TOKHelpBottomDlg), &OKHelpBottomDlg);
         Application->CreateForm(__classid(TOKRightDlg1), &OKRightDlg1);
         Application->Run();
    } catch(Exception &exception) {
         Application->ShowException(&exception);
    }

    return 0;
}

