/*
Kopic VCL Version 1.12
Producing Loto-7 combinations
Copyright 2017 Sogaya

C++Builder 5

*/

#include <vcl.h>
#pragma hdrstop

#include "Focus.h"
#include "kopicMain.h"
#include "kun.h"
#include "Version.h"
#include "Weight.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

char NO_BLOCK[KOPIC_KUN_SIZE];
extern bool EX_OR_array[XBM_HEIGHT][XBM_WIDTH];
extern bool xbm_boolean_array[XBM_HEIGHT][XBM_WIDTH];
extern KUN_CODE *kunCode;
extern TOKHelpBottomDlg *OKHelpBottomDlg;
extern TOKRightDlg *OKRightDlg;
extern TOKRightDlg1 *OKRightDlg1;
int untouched;
MANAGE_MEMO manage_memo; // rannuText.h
MANAGE_MEMO *mm = &manage_memo;
TForm1 *Form1;

__fastcall TForm1::TForm1(TComponent* Owner): TForm(Owner), CLEAR(" "), COMMA(","), EMPTY(""), GREEN_CIRCLE(""), KANJI_PATTERN(""), MENU(false), NEW_LINE("\n"), PREVIEW(true), RED_CURSOR(true), SINGLE_RECORD_UNDO(0), SMALL_SHOEBOX(""), SOLID_DIAMOND(""), SPACE(" "), WHITE_CURSOR(false), ZERO_X("0x") {
    cell_height = kunCode->cell_height;
    cell_width = kunCode->cell_width;
    data_height = kunCode->data_height;
    data_width = kunCode->data_width;
    decrement_by_n = kunCode->decrement_by_n;
    diamond = kunCode->diamond;

// The upper left corner of the Clear/Line/Fill block may be expressed as a circle or diamond or shoebox.
    const int SUBHEIGHT[17] = {216,216,216,216,216,256,296,376,398,MAIN_HEIGHT,MIDDLE_HEIGHT,518,558,598,638,678,718};
    const int SUBWIDTH[17] = {180,180,180,180,180,220,260,300,340,MAIN_WIDTH,MIDDLE_WIDTH,460,500,540,580,620,660};
    switch(diamond) {
    case DIAMOND:
        circle_diamond_shoebox = SOLID_DIAMOND;
        Height = SUBHEIGHT[cell_width];
        StringGrid1->Font->Size = cell_width - 5;
        Width = SUBWIDTH[cell_width];
        break;
    case KANJI: // hollow shoebox
        circle_diamond_shoebox = KANJI_PATTERN;
        Height = MIDDLE_HEIGHT;
        StringGrid1->Font->Size = 13;
        Width = MIDDLE_WIDTH;
        break;
    case SHOEBOX: // solid rectangle
        circle_diamond_shoebox = SMALL_SHOEBOX;
        Height = SUBHEIGHT[cell_width];
        StringGrid1->Font->Size = 6;
        Width = SUBWIDTH[cell_width];
        break;
    case SMALL_CIRCLE:
        circle_diamond_shoebox = GREEN_CIRCLE;
        Height = MAIN_HEIGHT;
        StringGrid1->Font->Size = 16;
        StringGrid1->Font->Style = StringGrid1->Font->Style << fsBold;
        Width = MAIN_WIDTH;
        break;
    default:
        circle_diamond_shoebox = GREEN_CIRCLE;
        Height = MAIN_HEIGHT;
        StringGrid1->Font->Size = 16;
        StringGrid1->Font->Style = StringGrid1->Font->Style << fsBold;
        Width = MAIN_WIDTH;
        break;
    }

    BorderStyle = bsSingle;
    HorzScrollBar->Visible = false;
    KeyPreview = true;
    Position = poScreenCenter;
    VertScrollBar->Visible = false;

    const int BORDER = 12;
    const int GRID_HEIGHT = cell_height * XBM_HEIGHT + BORDER;
    const int GRID_WIDTH = cell_width * XBM_WIDTH + BORDER;
    StringGrid1->DefaultColWidth = cell_width;
    StringGrid1->DefaultRowHeight = cell_height;
    StringGrid1->FixedCols = 0;
    StringGrid1->FixedRows = 0;
    StringGrid1->Font->Color = clGreen;
    StringGrid1->Height = GRID_HEIGHT;
    StringGrid1->Left = 0;
    StringGrid1->Options = StringGrid1->Options >> goFixedVertLine >> goFixedHorzLine >> goVertLine >> goHorzLine >> goRangeSelect;
    StringGrid1->ScrollBars = ssNone;
    StringGrid1->Top = 0;
    StringGrid1->Width = GRID_WIDTH;

    Edit1->AutoSize = false;
    Edit1->Height = LABEL_HEIGHT;
    Edit1->Left = 0;
    Edit1->Top = GRID_HEIGHT;
    Edit1->Width = GRID_WIDTH;
    Timer1->Interval = NONSAMPLING_PERIOD;

    goStart();
}

bool TForm1::kopicCsvTouched() {
    using namespace std;

// Checking if KOPIC_CSV exists
    ifstream csv(KOPIC_CSV);
    if( csv.fail() ) {
        return true;
    } else {
        csv.close();
    }

// Checking if KOPIC_CSV has been modified
    bool b = true;
    int m = modified_file(KOPIC_CSV);
    if(m == untouched) {
        b = false;
    } else {
        untouched = m;
    }

    return b;
}

bool TForm1::kunExpand() {
    using namespace std;     

    bool expanded[ XBM_HEIGHT * XBM_WIDTH ];
    const int XBM_HEIGHT_1 = XBM_HEIGHT + 1;
    const string NEW_LINE("\n");
    int black_or_white, count, DEL_count, n, q, sum, u;
    int estimated_width[ XBM_HEIGHT + 1 ];

    DEL_count = 0;
    n = 0;
    q = 0;
    sum = 0;
    for(int k = SIGNATURE; k < ks.kun_size && DEL_count < XBM_HEIGHT_1; k++, q++) {
        if(unexpanded[k] == DEL) {
            estimated_width[DEL_count] = sum;
            DEL_count += 1;
            q = 0;
            sum = 0;
            continue;
        }

        count = (int)unexpanded[k];
        sum += count;
        black_or_white = q%2;
        switch(black_or_white) {
        case BLACK:
            for(u = 0; u < count; u++) {
                expanded[n++] = true;
            }

            break;
        case WHITE:
            for(u = 0; u < count; u++) {
                expanded[n++] = false;
            }

            break;
        }

    }

// Checking if width is constant.
    data_height = DEL_count - 1;
    for(int m = 2; m < data_height; m++) {
        if(estimated_width[m] == estimated_width[1]) {
            continue;
        } else {
            ofstream file(ERROR_TEXT);
            file << "estimated_width[1] = " << estimated_width[1] << endl 
                << "estimated_width[" << m << "] = " << estimated_width[m] << endl;
            return false;
        }

    }

    data_width = estimated_width[1];
    n = 0;
    for(int m = 0; m < data_height; m++) {
        for(q = 0; q < data_width; q++, n++) {
            EX_OR_array[m][q] = xbm_boolean_array[m][q] ^ expanded[n];
            xbm_boolean_array[m][q] = expanded[n];
        }

    }

    return true;
}

bool TForm1::openDoubleRecordUndo() {
    using namespace std;

    const bool SERIAL_NUMBER = true;
    const TimeName undo1_bin(UND, BINARY_FILE);
    const TimeName undo2_bin(UND, BINARY_FILE);
    TimeName ub[2] = {undo1_bin, undo2_bin};

    for(int i = 0; i < 2; ++i) {
        timeNameText[i] = ub[i].temporaryName(SERIAL_NUMBER);

        if(! doubleRecordUndoClosed[i]) {
            putDoubleRecordUndo[i].close();
        }

        putDoubleRecordUndo[i].open( timeNameText[i].c_str(), ios::out | ios::binary );
        if( putDoubleRecordUndo[i].fail() ) {
            return false;
        }

        doubleRecordUndoClosed[i] = false;
        recordNumber[i] = 1;
    }

    return true;
}

bool TForm1::readUndoBin() {
    using namespace std;

    if(recordNumber[0] == 1) {
        return false;
    }

    if(! doubleRecordUndoClosed[0]) {
        putDoubleRecordUndo[0].close();
        doubleRecordUndoClosed[0] = true;
    }

    getDoubleRecordUndo[0].open( timeNameText[0].c_str(), ios::in | ios::binary );
    if( getDoubleRecordUndo[0].fail() ) {
        return false;
    }

    recordNumber[0] -= 1;
    streampos begin = RECORD_SIZE * ( recordNumber[0] - 1 );
    getDoubleRecordUndo[0].seekg(begin);
    getDoubleRecordUndo[0].read(record, RECORD_SIZE);
    getDoubleRecordUndo[0].close();

    int reverse_command = record[0];
    cell_x = record[1];
    cell_y = record[2];
    ud.previous_aim = record[3];
    ud.previous_item = record[4];
    ud.previous_x = record[5];
    ud.previous_y = record[6];
    ud.previous_block_x = record[7];
    ud.previous_block_y = record[8];

// little-endian architecture
    ks.size_bytes[0] = record[9];
    ks.size_bytes[1] = record[10];
    ks.size_bytes[2] = record[11];
    ks.size_bytes[3] = record[12];
    r.number_bytes[0] = record[ PARAMETER_COUNT - 4 ];
    r.number_bytes[1] = record[ PARAMETER_COUNT - 3 ];
    r.number_bytes[2] = record[ PARAMETER_COUNT - 2 ];
    r.number_bytes[3] = record[ PARAMETER_COUNT - 1 ];

    char *non_parameter = & record[PARAMETER_COUNT];
    if(ks.kun_size <= RECORD_SIZE - PARAMETER_COUNT) {
        memcpy(ud.unexpanded, non_parameter, KOPIC_KUN_SIZE);
    } else {
        if(! doubleRecordUndoClosed[1]) {
            putDoubleRecordUndo[1].close();
            doubleRecordUndoClosed[1] = true;
        }

        getDoubleRecordUndo[1].open( timeNameText[1].c_str(), ios::in | ios::binary );
        if( getDoubleRecordUndo[1].fail() ) {
            return false;
        }

        recordNumber[1] -= 1;
        streampos begin = FULL_RECORD_SIZE * ( recordNumber[1] - 1 );
        getDoubleRecordUndo[1].seekg(begin);
        getDoubleRecordUndo[1].read(full_record, FULL_RECORD_SIZE);
        getDoubleRecordUndo[1].close();

        non_parameter = & full_record[PARAMETER_COUNT];
        memcpy(ud.unexpanded, non_parameter, KOPIC_KUN_SIZE);
    }

    setStatusBar();

    switch(reverse_command) {
    case UNDO_CLEAR:
        undoClear();
        break;
    case UNDO_DRAW:
        undoDraw();
        break;
    case UNDO_END:
        undoEnd();
        break;
    case UNDO_FILL:
        undoFill();
        break;
    case UNDO_GO:
        undoGo();
        break;
    case UNDO_LINE:
        undoLine();
        break;
    case UNDO_START:
        undoStart();
        break;
    }

    return true;
}

bool TForm1::undoThat() {
    bool b = true;

    if(recordNumber[0] == 1) {
        return b;
    }

    if(first_undo) {
        firstUndo();
        if(! readUndoBin() ) {
            b = false;
        }

        first_undo = false;
    }

    if(! readUndoBin() ) {
        b = false;
    }

    return b;
}

int modified_file(const char *file_name) {
    AnsiString FILE_NAME(file_name);
    return FileAge(FILE_NAME);
}

void __fastcall TForm1::Bottom1Click(TObject *Sender) {
// Clear Bottom
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        const int DIAGONAL_Y = cell_y + 1;
        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < DIAGONAL_Y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Corner1Click(TObject *Sender) {
// Go Corner
    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x = focus_left;
    cell_y = focus_top;

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void __fastcall TForm1::CSV1Click(TObject *Sender) {
    using namespace std;

    const bool USE_38 = false;
    const int OMITTED = 0;
    kun->manageText(OMITTED);
    kun->createKopicCsv( inheritTerms(), data_width, data_height, USE_38);

// Reading a CSV file to produce KOPIC_CSV
    if(! readCsv(KOPIC_CSV, kunCode) ) {
        ofstream file(ERROR_TEXT);
        file << "NO_CSV" << endl;
        Close();
    }

    OKRightDlg1->textFields();
}

void __fastcall TForm1::Decrement1Click(TObject *Sender) {
    using namespace std;

    char buffer[ MAIN_BUFFER_SIZE + 1 ];
    const bool USE_38 = false;
    int decrement_according_to_file = 1;
    ifstream manage(MANAGE_TEXT);
    if( manage.fail() ) {
        ofstream file(MANAGE_TEXT);
        file << "1" << endl; // decrement_according_to_file
        file << CELL_WIDTH << endl;
        file << CELL_HEIGHT << endl;
        file << "1" << endl;
    } else {
        if( manage.getline(buffer, MAIN_BUFFER_SIZE) ) {
            string b(buffer);
            stringstream sb(b);
            sb >> decrement_according_to_file;
        }

    }

    kun->manageText(decrement_according_to_file);
    kun->createKopicCsv( inheritTerms(), data_width, data_height, USE_38);

// Reading a CSV file to produce KOPIC_CSV
    if(! readCsv(KOPIC_CSV, kunCode) ) {
        ofstream file(ERROR_TEXT);
        file << "NO_CSV" << endl;
        Close();
    }

    OKRightDlg1->textFields();
}

void __fastcall TForm1::Diagonal1Click(TObject *Sender) {
// Go Diagonal
    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x = focus_right - 1;
    cell_y = focus_bottom - 1;

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void __fastcall TForm1::Down1Click(TObject *Sender) {
    goDown(MENU);
}

void __fastcall TForm1::Down2Click(TObject *Sender) {
// Draw Down
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Down3Click(TObject *Sender) {
// Clear Down
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = focus_bottom - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::End1Click(TObject *Sender) {
// Go End
    slip(WHITE_CURSOR);
    Edit1->SetFocus();
}

void __fastcall TForm1::End2Click(TObject *Sender) {
// Draw End
    if(aim == DRAW) {
        aim = NO_AIM;
    }

}

void __fastcall TForm1::End3Click(TObject *Sender) {
    clearEnd();
}

void __fastcall TForm1::End4Click(TObject *Sender) {
    fillEnd();
}

void __fastcall TForm1::End5Click(TObject *Sender) {
    lineEnd();
}

void __fastcall TForm1::Exit1Click(TObject *Sender) {
    Close();
}

void __fastcall TForm1::Expand1Click(TObject *Sender) {
    if( ::kunExpand(KOPIC_KUN) ) {
        Close();
    }

}

void __fastcall TForm1::Focus1Click(TObject *Sender) {
    OKRightDlg->ShowModal();
}

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift) {
    if( StringGrid1->Focused() ) {
        home = true;
    }

}

void __fastcall TForm1::Fullswing1Click(TObject *Sender) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
    fullSwing(KOPIC_CSV);

    Close();
}

void __fastcall TForm1::Invert1Click(TObject *Sender) {
// Draw Invert
    draw_invert();
}

void __fastcall TForm1::Jump1Click(TObject *Sender) {
// Go Jump
    locateCursor();
}

void __fastcall TForm1::KUN1Click(TObject *Sender) {
    kun->shrink(data_width, data_height);
}

void __fastcall TForm1::N11Click(TObject *Sender) {
// Fill Down
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = focus_bottom - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::N13Click(TObject *Sender) {
// Fill Right
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = focus_right - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::N2Click(TObject *Sender) {
    goRight(MENU);
}

void __fastcall TForm1::N3Click(TObject *Sender) {
    goLeft(MENU);
}

void __fastcall TForm1::N6Click(TObject *Sender) {
// Draw Right
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = ud.previous_x;

            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = ud.previous_y - 1;
            }

        }

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::N7Click(TObject *Sender) {
// Draw Left
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_x -= 1;
        if(cell_x < focus_left) {
            cell_x = ud.previous_x;

            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = ud.previous_y - 1;
            }

        }

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::N9Click(TObject *Sender) {
// Clear Right
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_x += 1;
        if(cell_x >= focus_right) {
            cell_x = focus_right - 1;
        }

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::PDF1Click(TObject *Sender) {
    OKHelpBottomDlg->helpHandler();
}

void __fastcall TForm1::Right1Click(TObject *Sender) {
// Line Right
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x = focus_right - 1;
        cell_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(i == block_y) {
                    if(block_x <= k && k < focus_right) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Side1Click(TObject *Sender) {
// Clear Side
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        const int DIAGONAL_X = cell_x + 1;
        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < DIAGONAL_X) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_CLEAR;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Side2Click(TObject *Sender) {
// Fill Bottom
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        const int DIAGONAL_Y = cell_y + 1;
        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < DIAGONAL_Y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Side3Click(TObject *Sender) {
// Fill Side
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        const int DIAGONAL_X = cell_x + 1;
        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < DIAGONAL_X) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_FILL;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Start1Click(TObject *Sender) {
// Draw Start
    if(block) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;
    ud.previous_block_x = block_x;
    ud.previous_block_y = block_y;

    aim = DRAW;
    setStatusBar();
    red_cursor = true;

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_DRAW;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();

}

void __fastcall TForm1::Start2Click(TObject *Sender) {
// Clear Start
    clearStart();
}

void __fastcall TForm1::Start3Click(TObject *Sender) {
// Fill Start
    startBlock(FILL_BLOCK);
}

void __fastcall TForm1::Start4Click(TObject *Sender) {
// Line Start
    startBlock(LINE);
}

void __fastcall TForm1::StringGrid1DrawCell(TObject *Sender, int ACol, int ARow, TRect &Rect, TGridDrawState State) {
    if(ARow == block_y && ACol == block_x && block) {
        ;
    } else {
        if(block) {
            StringGrid1->Canvas->Brush->Color = clGray;
        } else {
            StringGrid1->Canvas->Brush->Color = clNavy;
        }

        if(xbm_boolean_array[ARow][ACol]) {
            StringGrid1->Canvas->FillRect(Rect);
        }

    }

    if(ACol == cell_x) {
        if(ARow == cell_y) {
            if(red_cursor) {
                StringGrid1->Canvas->Brush->Color = clRed;
            } else {
                StringGrid1->Canvas->Brush->Color = clWindow;
            }

            StringGrid1->Canvas->FillRect(Rect);
        }

    }

}

void __fastcall TForm1::StringGrid1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y) {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x = X/cell_width;
    cell_y = Y/cell_height;
    red_cursor = true;
    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void __fastcall TForm1::Text1Click(TObject *Sender) {
    kun->sharp_text(KOPIC_TEXT, data_width, data_height);
}

void __fastcall TForm1::Timer1Timer(TObject *Sender) {
    using namespace std;

    if(home) {
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();
        home = false;
    }

    if( kopicCsvTouched() ) {
        PICK_CODE pc = OKRightDlg1->setting(KOPIC_CSV, kunCode);
        if(pc.code != UNPICKED) {
            ofstream file(ERROR_TEXT);
            file << "kopicCsvTouched(): pc.code != UNPICKED" << endl;

            Application->Terminate();
        }

    }

}

void __fastcall TForm1::To1Click(TObject *Sender) {
// Line To
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        if(cell_x == block_x) {
            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = focus_right - 1;
            }

            if(cell_x == block_x) {
                cell_x -= 1;
                if(cell_x < focus_left) {
                    cell_x = focus_left;
                }

                if(cell_x == block_x) {
                    return;
                }

            }

        }

        if(cell_y == block_y) {
            cell_y += 1;
            if(cell_y >= focus_bottom) {
                cell_y = focus_bottom - 1;
            }

            if(cell_y == block_y) {
                cell_y -= 1;
                if(cell_y < focus_top) {
                    cell_y = focus_top;
                }

                if(cell_y == block_y) {
                    return;
                }

            }

        }
/*
block_y = slope * block_x + intercept
 cell_y = slope * cell_x + intercept
     dy = slope * dx + intercept
*/
        double dcx = (double)cell_x;
        double dcy = (double)cell_y;
        double dbx = (double)block_x;
        double dby = (double)block_y;
        double slope = (dby - dcy)/(dbx - dcx);
        double a_slope = fabs(slope);
        double intercept = (dby * dcx - dcy * dbx)/(dcx - dbx);

        if(a_slope < 1.0) {
            if(block_x <= cell_x) {
                if(block_y <= cell_y) {
                    gentleSlope(slope, intercept, block_x, cell_x, block_y, cell_y);
                } else {
                    gentleSlope(slope, intercept, block_x, cell_x, cell_y, block_y);
                }

            } else {
                if(block_y <= cell_y) {
                    gentleSlope(slope, intercept, cell_x, block_x, block_y, cell_y);
                } else {
                    gentleSlope(slope, intercept, cell_x, block_x, cell_y, block_y);
                }

            }

        } else {
            if(block_x <= cell_x) {
                if(block_y <= cell_y) {
                    steepSlope(slope, intercept, block_x, cell_x, block_y, cell_y);
                } else {
                    steepSlope(slope, intercept, block_x, cell_x, cell_y, block_y);
                }

            } else {
                if(block_y <= cell_y) {
                    steepSlope(slope, intercept, cell_x, block_x, block_y, cell_y);
                } else {
                    steepSlope(slope, intercept, cell_x, block_x, cell_y, block_y);
                }

            }

        }

        StringGrid1->Canvas->Brush->Color = clGreen;
        StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Under1Click(TObject *Sender) {
// Line Under
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        cell_x = block_x;
        cell_y = focus_bottom - 1;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < focus_bottom) {
                    if(k == block_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = true;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_LINE;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Undo1Click(TObject *Sender) {
    undoThat();
}

void __fastcall TForm1::Up1Click(TObject *Sender) {
    goUp(MENU);
}

void __fastcall TForm1::Up2Click(TObject *Sender) {
// Draw Up
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        xbm_boolean_array[cell_y][cell_x] = true;

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y -= 1;
        if(cell_y < focus_top) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void __fastcall TForm1::Version1Click(TObject *Sender) {
    OKHelpBottomDlg->ShowModal();        
}

void __fastcall TForm1::Weight1Click(TObject *Sender) {
    OKRightDlg1->ShowModal();        
}

void __fastcall TForm1::XBM1Click(TObject *Sender) {
    kun->rewrite_xbm(KOPIC_XBM, data_width, data_height);
}

void TForm1::addUndoData() {
    record[0] = (char)ud.reverse_command;
    record[1] = (char)ud.cell_x;
    record[2] = (char)ud.cell_y;
    record[3] = (char)ud.previous_aim;
    record[4] = (char)ud.previous_item;
    record[5] = (char)ud.previous_x;
    record[6] = (char)ud.previous_y;
    record[7] = (char)ud.previous_block_x;
    record[8] = (char)ud.previous_block_y;
    record[9] = ks.size_bytes[0];
    record[10] = ks.size_bytes[1];
    record[11] = ks.size_bytes[2];
    record[12] = ks.size_bytes[3];

    if( doubleRecordUndoClosed[0] | doubleRecordUndoClosed[1] ) {
        openDoubleRecordUndo();
    }

    char *p = & record[PARAMETER_COUNT];
    if(ud.unexpanded != & NO_BLOCK[0]) {
        memcpy(p, ud.unexpanded, RECORD_SIZE - PARAMETER_COUNT);
    }

    std::streampos begin = RECORD_SIZE * ( recordNumber[0] - 1 );
    putDoubleRecordUndo[0].seekp(begin);
    putDoubleRecordUndo[0].write(record, RECORD_SIZE);

    first_undo = true;

// Setting the next record number
    recordNumber[0] += 1;

    if(ks.kun_size <= RECORD_SIZE - PARAMETER_COUNT) {
        r.record_number = recordNumber[0];
        record[ PARAMETER_COUNT - 4 ] = r.number_bytes[0];
        record[ PARAMETER_COUNT - 3 ] = r.number_bytes[1];
        record[ PARAMETER_COUNT - 2 ] = r.number_bytes[2];
        record[ PARAMETER_COUNT - 1 ] = r.number_bytes[3];
    } else {
        r.record_number = recordNumber[1];
        record[ PARAMETER_COUNT - 4 ] = r.number_bytes[0];
        record[ PARAMETER_COUNT - 3 ] = r.number_bytes[1];
        record[ PARAMETER_COUNT - 2 ] = r.number_bytes[2];
        record[ PARAMETER_COUNT - 1 ] = r.number_bytes[3];

// full_record is larger than record so that full_record can preserve the integrity.
        memset(full_record, 0, FULL_RECORD_SIZE);
        for(int i = 0; i < PARAMETER_COUNT; ++i) {
            full_record[i] = record[i];
        }

        p = & full_record[PARAMETER_COUNT];
        memcpy(p, ud.unexpanded, KOPIC_KUN_SIZE);
        begin = FULL_RECORD_SIZE * ( recordNumber[1] - 1 );
        putDoubleRecordUndo[1].seekp(begin);
        putDoubleRecordUndo[1].write(full_record, FULL_RECORD_SIZE);

// Setting the next record number
        recordNumber[1] += 1;
    }

}

void TForm1::clearEnd() {
    if(aim == CLEAR_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        if(xbm_boolean_array[block_y][block_x]) {
            StringGrid1->Canvas->Brush->Color = clNavy;
        } else {
            StringGrid1->Canvas->Brush->Color = clWindow;
        }

        StringGrid1->Cells[block_x][block_y] = CLEAR;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = false;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void TForm1::clearStart() {
    startBlock(CLEAR_BLOCK);
}

void TForm1::draw_invert() {
    if(aim == DRAW) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];
        if(xbm_boolean_array[cell_y][cell_x]) {
            xbm_boolean_array[cell_y][cell_x] = false;
        } else {
            xbm_boolean_array[cell_y][cell_x] = true;
        }

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_y += 1;
        if(cell_y >= focus_bottom) {
            cell_y = ud.previous_y;

            cell_x += 1;
            if(cell_x >= focus_right) {
                cell_x = ud.previous_x - 1;
            }

        }

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_DRAW;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void TForm1::fillEnd() {
    if(aim == FILL_BLOCK) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        if(xbm_boolean_array[block_y][block_x]) {
            StringGrid1->Canvas->Brush->Color = clNavy;
        } else {
            StringGrid1->Canvas->Brush->Color = clWindow;
        }

        StringGrid1->Cells[block_x][block_y] = CLEAR;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; ++i) {
            for(int k = 0; k < XBM_WIDTH; ++k) {
                if(block_y <= i && i < cell_y) {
                    if(block_x <= k && k < cell_x) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void TForm1::firstUndo() {
    startBlock(FIRST_UNDO);
}

void TForm1::focussing(std::string & s, int l, int t, int r, int b) {
    focus_bottom = b;
    focus_left = l;
    focus_right = r;
    focus_top = t;

    AnsiString editText( s.c_str() );
    Edit1->Text = editText;
}

void TForm1::gentleSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y) {
    double dx, dy, interval_0, interval_1;

    for(int i = 0; i < XBM_HEIGHT; ++i) {
        for(int k = 0; k < XBM_WIDTH; ++k) {
            if(from_y <= i && i < to_y) {
                if(from_x <= k && k < to_x) {
                    interval_0 = (double)i;
                    interval_1 = (double)i + 1.0;
                    dx = (double)k + 0.5;
                    dy = slope * dx + intercept;
                    if(interval_0 <= dy && dy < interval_1) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

            }

            if(xbm_boolean_array[i][k]) {
                StringGrid1->Canvas->Brush->Color = clNavy;
            } else {
                StringGrid1->Canvas->Brush->Color = clWindow;
            }

            StringGrid1->Col = k;
            StringGrid1->Row = i;
        }

    }

}

void TForm1::goDown(bool preview) {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_y += 1;
    if(cell_y >= focus_bottom) {
        cell_y = focus_bottom - 1;
    }

    setStatusBar();
    if(! preview) {
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
    }

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::goLeft(bool preview) {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x -= 1;
    if(cell_x < focus_left) {
        cell_x = focus_left;
    }

    red_cursor = true;
    if(! preview) {
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
    }

    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::goRight(bool preview) {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_x += 1;
    if(cell_x >= focus_right) {
        cell_x = focus_right - 1;
    }

    red_cursor = true;
    if(! preview) {
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
    }

    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::goStart() {
// Focussing
    focus_left = 0;
    focus_right = data_width;
    focus_top = 0;
    focus_bottom = data_height;

// Reaching the upper left corner
    cell_x = focus_left;
    cell_y = focus_top;
    aim = GO;
    block = false;
    home = false;
    red_cursor = true;

// Placing squares accroding to the array
    kun = new Kun(decrement_by_n);
    kun->xbmBooleanArray(data_width, data_height);
    set_EX_OR_array();

// Neither clearing nor filling
    block_x = cell_x;
    block_y = cell_y;
    persistent = false;

// Before undo
    doubleRecordUndoClosed[0] = true;
    doubleRecordUndoClosed[1] = true;
    openDoubleRecordUndo();
    no_block.kun_size = 0;

    setStatusBar();
    untouched = modified_file(KOPIC_CSV);
}

void TForm1::goUp(bool preview) {
    if(block && persistent) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    cell_y -= 1;
    if(cell_y < focus_top) {
        cell_y = focus_top;
    }

    setStatusBar();
    if(! preview) {
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
    }

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::lineEnd() {
    if(aim == LINE) {
        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;
        ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

        aim = NO_AIM;
        block = false;
        if(xbm_boolean_array[block_y][block_x]) {
            StringGrid1->Canvas->Brush->Color = clNavy;
        } else {
            StringGrid1->Canvas->Brush->Color = clWindow;
        }

        StringGrid1->Cells[block_x][block_y] = CLEAR;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
        ud.previous_block_x = block_x;
        ud.previous_block_y = block_y;

        cell_x = block_x;
        cell_y = block_y;

        for(int i = 0; i < XBM_HEIGHT; i += 1) {
            for(int k = 0; k < XBM_WIDTH; k += 1) {
                if(xbm_boolean_array[i][k]) {
                    StringGrid1->Canvas->Brush->Color = clNavy;
                } else {
                    StringGrid1->Canvas->Brush->Color = clWindow;
                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

        StringGrid1->Canvas->Brush->Color = clRed;
        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        persistent = false;
        ud.unexpanded = & unexpanded[0];
        ud.reverse_command = UNDO_END;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void TForm1::locateCursor() {
    POINT pos;
    ::GetCursorPos( &pos );

    const int BORDER = 5;
    const int HEAD = 43;
    const int upper_left_x = Left + BORDER;
    const int upper_left_y = Top + HEAD;
    const int upper_right_x = upper_left_x + StringGrid1->Width;
    const int lower_left_y = upper_left_y + StringGrid1->Height;
    bool inside = false;

    if(upper_left_x < pos.x && pos.x < upper_right_x) {
        if(upper_left_y < pos.y && pos.y < lower_left_y) {
            inside = true;
        }

    }

    if(inside) {
        if(block && persistent) {
            switch(aim) {
            case CLEAR_BLOCK:
                clearEnd();
                break;
            case FILL_BLOCK:
                fillEnd();
                break;
            case LINE:
                lineEnd();
                break;
            }

            return;
        }

        ud.previous_item = xbm_boolean_array[cell_y][cell_x];

        ud.previous_aim = aim;
        ud.previous_x = cell_x;
        ud.previous_y = cell_y;

        cell_x = ( pos.x - upper_left_x )/cell_width;
        cell_y = ( pos.y - upper_left_y )/cell_height;

        red_cursor = true;
        StringGrid1->Col = cell_x;
        StringGrid1->Row = cell_y;
        setStatusBar();

        ks = no_block;
        ud.unexpanded = & NO_BLOCK[0];
        ud.reverse_command = UNDO_GO;
        ud.cell_x = cell_x;
        ud.cell_y = cell_y;
        addUndoData();
    }

}

void TForm1::moveDiamond(int new_x, int new_y) {
    if(xbm_boolean_array[block_y][block_x]) {
        StringGrid1->Canvas->Brush->Color = clNavy;
    } else {
        StringGrid1->Canvas->Brush->Color = clWindow;
    }

    StringGrid1->Cells[block_x][block_y] = CLEAR;
    StringGrid1->Col = block_x;
    StringGrid1->Row = block_y;

    block_x = new_x;
    block_y = new_y;
    StringGrid1->Cells[block_x][block_y] = circle_diamond_shoebox;
    StringGrid1->Col = block_x;
    StringGrid1->Row = block_y;
}

void TForm1::placeSuaresAccordingToArray() {
    for(int i = focus_top; i < focus_bottom; i += 1) {
        for(int k = focus_left; k < focus_right; k += 1) {
            if(i == block_y && k == block_x && block) {
                ;
            } else {
                if( EX_OR_array[i][k] ) {
                    if(xbm_boolean_array[i][k]) {
                        if(block) {
                            StringGrid1->Canvas->Brush->Color = clGray;
                        } else {
                            StringGrid1->Canvas->Brush->Color = clNavy;
                        }

                    }

                }

                StringGrid1->Col = k;
                StringGrid1->Row = i;
            }

        }

    }

    StringGrid1->Canvas->Brush->Color = clRed;
    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();
}

void TForm1::set_EX_OR_array() {
    for(int m = 0; m < data_height; ++m) {
        for(int q = 0; q < data_width; ++q) {
            EX_OR_array[m][q] = true;
        }

    }

}

void TForm1::setStatusBar() {
    using namespace std;

    stringstream os;
    os << cell_x << COMMA << cell_y;
    string s = os.str();
    AnsiString statusBarText( s.c_str() );
    Edit1->Text = statusBarText;
}

void TForm1::slip(bool r) {
    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;

    if(cell_x) {
        cell_x = 0;
    } else {
        cell_x = 1;
    }

    if(cell_y) {
        cell_y = 0;
    } else {
        cell_y = 1;
    }

    red_cursor = r;
    if(red_cursor) {
        StringGrid1->Canvas->Brush->Color = clRed;
    } else {
        StringGrid1->Canvas->Brush->Color = clWindow;
    }

    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();

    ks = no_block;
    ud.unexpanded = & NO_BLOCK[0];
    ud.reverse_command = UNDO_GO;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::startBlock(enum AIM a) {
    if(block) {
        switch(aim) {
        case CLEAR_BLOCK:
            clearEnd();
            break;
        case FILL_BLOCK:
            fillEnd();
            break;
        case LINE:
            lineEnd();
            break;
        }

        return;
    }

    ud.previous_item = xbm_boolean_array[cell_y][cell_x];

    ud.previous_aim = aim;
    ud.previous_x = cell_x;
    ud.previous_y = cell_y;
    ud.previous_block_x = block_x;
    ud.previous_block_y = block_y;
    ks.kun_size = kun->shrink(unexpanded, data_width, data_height);

    block = true;
    placeSuaresAccordingToArray();
    moveDiamond(cell_x, cell_y);

    aim = a;
    setStatusBar();

    ud.unexpanded = & unexpanded[0];
    ud.reverse_command = UNDO_START;
    ud.cell_x = cell_x;
    ud.cell_y = cell_y;
    addUndoData();
}

void TForm1::steepSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y) {
    double dx, dy, interval_0, interval_1;

    for(int k = 0; k < XBM_WIDTH; ++k) {
        for(int i = 0; i < XBM_HEIGHT; ++i) {
            if(from_y <= i && i < to_y) {
                if(from_x <= k && k < to_x) {
                    interval_0 = (double)k;
                    interval_1 = (double)k + 1.0;
                    dy = (double)i + 0.5;
                    dx = ( dy - intercept )/slope;
                    if(interval_0 <= dx && dx < interval_1) {
                        xbm_boolean_array[i][k] = true;
                    }

                }

            }

            if(xbm_boolean_array[i][k]) {
                StringGrid1->Canvas->Brush->Color = clNavy;
            } else {
                StringGrid1->Canvas->Brush->Color = clWindow;
            }

            StringGrid1->Col = k;
            StringGrid1->Row = i;
        }

    }

}

void TForm1::temporaryFileName(char *name) {
    AnsiString editText(name);
    Edit1->Text = editText;
}

void TForm1::undoBlock() {
    aim = ud.previous_aim;

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    block = true;
    kunExpand(); // EX_OR_array[][]
    placeSuaresAccordingToArray();
    set_EX_OR_array();

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();
}

void TForm1::undoClear() {
    undoBlock();
}

void TForm1::undoDraw() {
    cell_x = ud.previous_x;
    cell_y = ud.previous_y;
    xbm_boolean_array[cell_y][cell_x] = ud.previous_item;

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();
}

void TForm1::undoEnd() {
    if(ud.previous_aim == CLEAR_BLOCK || ud.previous_aim == FILL_BLOCK || ud.previous_aim == LINE) {
        moveDiamond(ud.previous_block_x, ud.previous_block_y);
    }

    aim = ud.previous_aim;

    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    block = true;
    kunExpand();
    set_EX_OR_array();
    placeSuaresAccordingToArray();

    setStatusBar();
}

void TForm1::undoFill() {
    undoBlock();
}

void TForm1::undoGo() {
    cell_x = ud.previous_x;
    cell_y = ud.previous_y;

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();
}

void TForm1::undoLine() {
    undoBlock();
}

void TForm1::undoStart() {
    if(ud.previous_aim == CLEAR_BLOCK || ud.previous_aim == FILL_BLOCK || ud.previous_aim == FIRST_UNDO || ud.previous_aim == LINE) {
        moveDiamond(ud.previous_block_x, ud.previous_block_y);
    } else {
        StringGrid1->Cells[block_x][block_y] = CLEAR;
        StringGrid1->Col = block_x;
        StringGrid1->Row = block_y;
    }

    aim = ud.previous_aim;

    block = false;
    placeSuaresAccordingToArray();

    red_cursor = true;
    StringGrid1->Col = cell_x;
    StringGrid1->Row = cell_y;
    setStatusBar();
}

