#ifndef kopicMainH
#define kopicMainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include "kun.h"
#include "TimeName.h"

enum AIM {
    NO_AIM,
    CLEAR_BLOCK,
    DRAW,
    END_BLOCK,
    FILL_BLOCK,
    FIRST_UNDO,
    GO,
    LINE,
    START_BLOCK
};

enum REVERSE_COMMAND {
    NO_OPERATION,
    UNDO_CLEAR,
    UNDO_DRAW,
    UNDO_END,
    UNDO_FILL,
    UNDO_GO,
    UNDO_LINE,
    UNDO_START
};

typedef struct UNDO_DATA UNDO_DATA;
struct UNDO_DATA {
    bool previous_item;
    char *unexpanded;
    enum REVERSE_COMMAND reverse_command;
    int cell_x, cell_y, previous_aim, previous_block_x, previous_block_y, previous_x, previous_y;
};

class TForm1 : public TForm
{
__published:
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TMenuItem *Setting1;
    TMenuItem *Focus1;
    TMenuItem *Weight1;
    TMenuItem *Help1;
    TMenuItem *Version1;
    TStringGrid *StringGrid1;
    TMenuItem *Go1;
    TMenuItem *End1;
    TMenuItem *Down1;
    TMenuItem *N1;
    TMenuItem *Up1;
    TMenuItem *N2;
    TMenuItem *N3;
    TMenuItem *Undo1;
    TEdit *Edit1;
    TMenuItem *Jump1;
    TMenuItem *Diagonal1;
    TMenuItem *Corner1;
    TMenuItem *Draw1;
    TMenuItem *Down2;
    TMenuItem *Start1;
    TMenuItem *End2;
    TMenuItem *N4;
    TMenuItem *Invert1;
    TMenuItem *N5;
    TMenuItem *Up2;
    TMenuItem *N6;
    TMenuItem *N7;
    TMenuItem *Clear1;
    TMenuItem *Start2;
    TMenuItem *End3;
    TMenuItem *N8;
    TMenuItem *N9;
    TMenuItem *Down3;
    TMenuItem *N10;
    TMenuItem *Side1;
    TMenuItem *Bottom1;
    TTimer *Timer1;
    TMenuItem *Fill1;
    TMenuItem *End4;
    TMenuItem *Start3;
    TMenuItem *N11;
    TMenuItem *N12;
    TMenuItem *N13;
    TMenuItem *N14;
    TMenuItem *Side2;
    TMenuItem *Side3;
    TMenuItem *Line1;
    TMenuItem *End5;
    TMenuItem *Start4;
    TMenuItem *N15;
    TMenuItem *To1;
    TMenuItem *N16;
    TMenuItem *Right1;
    TMenuItem *Under1;
    TMenuItem *CSV1;
    TMenuItem *Decrement1;
    TMenuItem *KUN1;
    TMenuItem *Text1;
    TMenuItem *XBM1;
    TMenuItem *N17;
    TMenuItem *Expand1;
    TMenuItem *Fullswing1;
    TMenuItem *PDF1;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Focus1Click(TObject *Sender);
    void __fastcall Weight1Click(TObject *Sender);
    void __fastcall Version1Click(TObject *Sender);
    void __fastcall StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State);
    void __fastcall StringGrid1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall Down1Click(TObject *Sender);
    void __fastcall Up1Click(TObject *Sender);
    void __fastcall N2Click(TObject *Sender);
    void __fastcall N3Click(TObject *Sender);
    void __fastcall Undo1Click(TObject *Sender);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift);
    void __fastcall End1Click(TObject *Sender);
    void __fastcall Jump1Click(TObject *Sender);
    void __fastcall Diagonal1Click(TObject *Sender);
    void __fastcall Corner1Click(TObject *Sender);
    void __fastcall Start1Click(TObject *Sender);
    void __fastcall Down2Click(TObject *Sender);
    void __fastcall End2Click(TObject *Sender);
    void __fastcall N7Click(TObject *Sender);
    void __fastcall N6Click(TObject *Sender);
    void __fastcall Up2Click(TObject *Sender);
    void __fastcall Invert1Click(TObject *Sender);
    void __fastcall Start2Click(TObject *Sender);
    void __fastcall End3Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Down3Click(TObject *Sender);
    void __fastcall N9Click(TObject *Sender);
    void __fastcall Side1Click(TObject *Sender);
    void __fastcall Bottom1Click(TObject *Sender);
    void __fastcall Start3Click(TObject *Sender);
    void __fastcall End4Click(TObject *Sender);
    void __fastcall N13Click(TObject *Sender);
    void __fastcall N11Click(TObject *Sender);
    void __fastcall Side3Click(TObject *Sender);
    void __fastcall Side2Click(TObject *Sender);
    void __fastcall End5Click(TObject *Sender);
    void __fastcall Start4Click(TObject *Sender);
    void __fastcall To1Click(TObject *Sender);
    void __fastcall Right1Click(TObject *Sender);
    void __fastcall Under1Click(TObject *Sender);
    void __fastcall CSV1Click(TObject *Sender);
    void __fastcall Decrement1Click(TObject *Sender);
    void __fastcall KUN1Click(TObject *Sender);
    void __fastcall Text1Click(TObject *Sender);
    void __fastcall XBM1Click(TObject *Sender);
    void __fastcall Expand1Click(TObject *Sender);
    void __fastcall Fullswing1Click(TObject *Sender);
    void __fastcall PDF1Click(TObject *Sender);
private:
    AnsiString circle_diamond_shoebox;
    bool block, first_undo, home, persistent, red_cursor;
    bool doubleRecordUndoClosed[2];
    char full_record[FULL_RECORD_SIZE];
    char record[RECORD_SIZE];
    char unexpanded[KOPIC_KUN_SIZE];
    const AnsiString CLEAR, GREEN_CIRCLE, KANJI_PATTERN, SMALL_SHOEBOX, SOLID_DIAMOND;
    const bool MENU, PREVIEW, RED_CURSOR, WHITE_CURSOR;
    const int SINGLE_RECORD_UNDO;
    const std::string COMMA, EMPTY, NEW_LINE, SPACE, ZERO_X;
    std::ifstream getDoubleRecordUndo[2];
    int aim, block_x, block_y, cell_height, cell_width, cell_x, cell_y, cursor_color, data_height, data_width, decrement_by_n, diamond, focus_bottom, focus_left, focus_right, focus_top, main_height, main_width, main_x, main_y;
    int recordNumber[2];
    Kun *kun;
    std::ofstream putDoubleRecordUndo[2];
    std::string timeNameText[2];
    UNDO_DATA ud;
    union KUN_SIZE {
        char size_bytes[4];
        int kun_size;
    } ks, no_block;
    union RECORD_NUMBER {
        char number_bytes[4];
        int record_number;
    } r;

    bool kunExpand();
    bool openDoubleRecordUndo();
    bool readUndoBin();
    bool undoThat();
    void addUndoData();
    void clearEnd();
    void clearStart();
    void draw_invert();
    void firstUndo();
    void fillEnd();
    void gentleSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y);
    void goDown(bool preview);
    void goLeft(bool preview);
    void goRight(bool preview);
    void goStart();
    void goUp(bool preview);
    void lineEnd();
    void locateCursor();
    void moveDiamond(int new_x, int new_y);
    void placeSuaresAccordingToArray();
    void set_EX_OR_array();
    void setStatusBar();
    void slip(bool r);
    void startBlock(enum AIM a);
    void steepSlope(double slope, double intercept, int from_x, int to_x, int from_y, int to_y);
    void undoBlock();
    void undoClear();
    void undoDraw();
    void undoEnd();
    void undoFill();
    void undoGo();
    void undoLine();
    void undoStart();
public:
    bool kopicCsvTouched();
    __fastcall TForm1(TComponent* Owner);
    void focussing(std::string & s, int l, int t, int r, int b);
    void temporaryFileName(char *name);
};

extern PACKAGE TForm1 *Form1;

#endif
